diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-ru-allocation-test.cc ns-3.45/src/wifi/test/wifi-ru-allocation-test.cc
--- ns-3.44/src/wifi/test/wifi-ru-allocation-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-ru-allocation-test.cc	2025-06-01 20:34:45.643702300 -0700
@@ -434,80 +484,92 @@
         // The first 9 26-tone RUs are in the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 9 26-tone RUs are in the second 20 MHz channel
         for (std::size_t idx = 10; idx <= 18; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {ch20Index1});
+        }
+        if (m_standard == WIFI_STANDARD_80211ax)
+        {
+            // The center 26-tone RU is covered by the central 20 MHz channels
+            RunOne(p20Index,
+                   MakeRuSpec(RuType::RU_26_TONE, 19, p80, p160),
+                   width,
+                   {ch20Index1, ch20Index2});
         }
-        // The center 26-tone RU is covered by the central 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, 19, true), width, {ch20Index1, ch20Index2});
         // The following 9 26-tone RUs are in the third 20 MHz channel
         for (std::size_t idx = 20; idx <= 28; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {ch20Index2});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {ch20Index2});
         }
         // The last 9 26-tone RUs are in the fourth 20 MHz channel
         for (std::size_t idx = 29; idx <= 37; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {ch20Index3});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {ch20Index3});
         }
         // The first 4 52-tone RUs are in the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 4 52-tone RUs are in the second 20 MHz channel
         for (std::size_t idx = 5; idx <= 8; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {ch20Index1});
         }
         // The third 4 52-tone RUs are in the third 20 MHz channel
         for (std::size_t idx = 9; idx <= 12; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {ch20Index2});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {ch20Index2});
         }
         // The fourth 4 52-tone RUs are in the fourth 20 MHz channel
         for (std::size_t idx = 13; idx <= 16; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {ch20Index3});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {ch20Index3});
         }
         // The first 2 106-tone RUs are in the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 2 106-tone RUs are in the second 20 MHz channel
         for (std::size_t idx = 3; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {ch20Index1});
         }
         // The third 2 106-tone RUs are in the third 20 MHz channel
         for (std::size_t idx = 5; idx <= 6; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {ch20Index2});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {ch20Index2});
         }
         // The fourth 2 106-tone RUs are in the fourth 20 MHz channel
         for (std::size_t idx = 7; idx <= 8; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {ch20Index3});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {ch20Index3});
         }
         // The first 242-tone RU is in the first 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {ch20Index0});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {ch20Index0});
         // The second 242-tone RU is in the second 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 2, true), width, {ch20Index1});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 2, p80, p160), width, {ch20Index1});
         // The third 242-tone RU is in the third 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 3, true), width, {ch20Index2});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 3, p80, p160), width, {ch20Index2});
         // The fourth 242-tone RU is in the fourth 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 4, true), width, {ch20Index3});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 4, p80, p160), width, {ch20Index3});
         // The first 484-tone RU is covered by the first two 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_484_TONE, 1, true), width, {ch20Index0, ch20Index1});
+        RunOne(p20Index,
+               MakeRuSpec(RuType::RU_484_TONE, 1, p80, p160),
+               width,
+               {ch20Index0, ch20Index1});
         // The second 484-tone RU is covered by the last two 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_484_TONE, 2, true), width, {ch20Index2, ch20Index3});
+        RunOne(p20Index,
+               MakeRuSpec(RuType::RU_484_TONE, 2, p80, p160),
+               width,
+               {ch20Index2, ch20Index3});
         // The 996-tone RU is covered by all the 20 MHz channels
         RunOne(p20Index,
-               HeRu::RuSpec(HeRu::RU_996_TONE, 1, true),
+               MakeRuSpec(RuType::RU_996_TONE, 1, p80, p160),
                width,
                {ch20Index0, ch20Index1, ch20Index2, ch20Index3});
     }
@@ -517,144 +579,186 @@
     {
         const MHz_u width{160};
 
-        for (auto primary80MHz : {true, false})
+        for (auto primary80 : {true, false})
         {
             // RUs can be allocated in one (or more) of the four 20 MHz channels in P80/S80
-            // (depending on the primary80MHz flag)
-            const uint8_t p80Index = (primary80MHz == (p20Index < 4)) ? 0 : 1;
+            // (depending on the primary80 flag)
+            const uint8_t p80Index = (primary80 == (p20Index < 4)) ? 0 : 1;
             const uint8_t ch20Index0 = p80Index * 4;
             const uint8_t ch20Index1 = p80Index * 4 + 1;
             const uint8_t ch20Index2 = p80Index * 4 + 2;
             const uint8_t ch20Index3 = p80Index * 4 + 3;
 
             // The first 9 26-tone RUs are in the first 20 MHz channel
-            for (std::size_t idx = 1; idx <= 9; idx++)
+            std::size_t startIdx = 1;
+            std::size_t stopIdx = startIdx + 8;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_26_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_26_TONE, idx, primary80, p160),
                        width,
                        {ch20Index0});
             }
             // The second 9 26-tone RUs are in the second 20 MHz channel
-            for (std::size_t idx = 10; idx <= 18; idx++)
+            startIdx = stopIdx + 1;
+            stopIdx = startIdx + 8;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_26_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_26_TONE, idx, primary80, p160),
                        width,
                        {ch20Index1});
             }
-            // The center 26-tone RU is covered by the central 20 MHz channels
-            RunOne(p20Index,
-                   HeRu::RuSpec(HeRu::RU_26_TONE, 19, primary80MHz),
-                   width,
-                   {ch20Index1, ch20Index2});
+            if (m_standard == WIFI_STANDARD_80211ax)
+            {
+                // The center 26-tone RU is covered by the central 20 MHz channels
+                RunOne(p20Index,
+                       MakeRuSpec(RuType::RU_26_TONE, 19, primary80, p160),
+                       width,
+                       {ch20Index1, ch20Index2});
+            }
             // The following 9 26-tone RUs are in the third 20 MHz channel
-            for (std::size_t idx = 20; idx <= 28; idx++)
+            startIdx = stopIdx + 2;
+            stopIdx = startIdx + 8;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_26_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_26_TONE, idx, primary80, p160),
                        width,
                        {ch20Index2});
             }
             // The last 9 26-tone RUs are in the fourth 20 MHz channel
-            for (std::size_t idx = 29; idx <= 37; idx++)
+            startIdx = stopIdx + 1;
+            stopIdx = startIdx + 8;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_26_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_26_TONE, idx, primary80, p160),
                        width,
                        {ch20Index3});
             }
             // The first 4 52-tone RUs are in the first 20 MHz channel
-            for (std::size_t idx = 1; idx <= 4; idx++)
+            startIdx = 1;
+            stopIdx = startIdx + 3;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_52_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_52_TONE, idx, primary80, p160),
                        width,
                        {ch20Index0});
             }
             // The second 4 52-tone RUs are in the second 20 MHz channel
-            for (std::size_t idx = 5; idx <= 8; idx++)
+            startIdx = stopIdx + 1;
+            stopIdx = startIdx + 3;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_52_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_52_TONE, idx, primary80, p160),
                        width,
                        {ch20Index1});
             }
             // The third 4 52-tone RUs are in the third 20 MHz channel
-            for (std::size_t idx = 9; idx <= 12; idx++)
+            startIdx = stopIdx + 1;
+            stopIdx = startIdx + 3;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_52_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_52_TONE, idx, primary80, p160),
                        width,
                        {ch20Index2});
             }
             // The fourth 4 52-tone RUs are in the fourth 20 MHz channel
-            for (std::size_t idx = 13; idx <= 16; idx++)
+            startIdx = stopIdx + 1;
+            stopIdx = startIdx + 3;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_52_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_52_TONE, idx, primary80, p160),
                        width,
                        {ch20Index3});
             }
             // The first 2 106-tone RUs are in the first 20 MHz channel
-            for (std::size_t idx = 1; idx <= 2; idx++)
+            startIdx = 1;
+            stopIdx = startIdx + 1;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_106_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_106_TONE, idx, primary80, p160),
                        width,
                        {ch20Index0});
             }
             // The second 2 106-tone RUs are in the second 20 MHz channel
-            for (std::size_t idx = 3; idx <= 4; idx++)
+            startIdx = stopIdx + 1;
+            stopIdx = startIdx + 1;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_106_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_106_TONE, idx, primary80, p160),
                        width,
                        {ch20Index1});
             }
             // The third 2 106-tone RUs are in the third 20 MHz channel
-            for (std::size_t idx = 5; idx <= 6; idx++)
+            startIdx = stopIdx + 1;
+            stopIdx = startIdx + 1;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_106_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_106_TONE, idx, primary80, p160),
                        width,
                        {ch20Index2});
             }
             // The fourth 2 106-tone RUs are in the fourth 20 MHz channel
-            for (std::size_t idx = 7; idx <= 8; idx++)
+            startIdx = stopIdx + 1;
+            stopIdx = startIdx + 1;
+            for (std::size_t idx = startIdx; idx <= stopIdx; idx++)
             {
                 RunOne(p20Index,
-                       HeRu::RuSpec(HeRu::RU_106_TONE, idx, primary80MHz),
+                       MakeRuSpec(RuType::RU_106_TONE, idx, primary80, p160),
                        width,
                        {ch20Index3});
             }
             // The first 242-tone RU is in the first 20 MHz channel
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, primary80MHz), width, {ch20Index0});
+            auto idx = 1;
+            RunOne(p20Index,
+                   MakeRuSpec(RuType::RU_242_TONE, idx++, primary80, p160),
+                   width,
+                   {ch20Index0});
             // The second 242-tone RU is in the second 20 MHz channel
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 2, primary80MHz), width, {ch20Index1});
+            RunOne(p20Index,
+                   MakeRuSpec(RuType::RU_242_TONE, idx++, primary80, p160),
+                   width,
+                   {ch20Index1});
             // The third 242-tone RU is in the third 20 MHz channel
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 3, primary80MHz), width, {ch20Index2});
+            RunOne(p20Index,
+                   MakeRuSpec(RuType::RU_242_TONE, idx++, primary80, p160),
+                   width,
+                   {ch20Index2});
             // The fourth 242-tone RU is in the fourth 20 MHz channel
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 4, primary80MHz), width, {ch20Index3});
+            RunOne(p20Index,
+                   MakeRuSpec(RuType::RU_242_TONE, idx, primary80, p160),
+                   width,
+                   {ch20Index3});
             // The first 484-tone RU is covered by the first two 20 MHz channels
+            idx = 1;
             RunOne(p20Index,
-                   HeRu::RuSpec(HeRu::RU_484_TONE, 1, primary80MHz),
+                   MakeRuSpec(RuType::RU_484_TONE, idx++, primary80, p160),
                    width,
                    {ch20Index0, ch20Index1});
             // The second 484-tone RU is covered by the last two 20 MHz channels
             RunOne(p20Index,
-                   HeRu::RuSpec(HeRu::RU_484_TONE, 2, primary80MHz),
+                   MakeRuSpec(RuType::RU_484_TONE, idx, primary80, p160),
                    width,
                    {ch20Index2, ch20Index3});
             // The 996-tone RU is covered by all the 20 MHz channels
+            idx = 1;
             RunOne(p20Index,
-                   HeRu::RuSpec(HeRu::RU_996_TONE, 1, primary80MHz),
+                   MakeRuSpec(RuType::RU_996_TONE, idx, primary80, p160),
                    width,
                    {ch20Index0, ch20Index1, ch20Index2, ch20Index3});
         }
         // The 2x996-tone RU is covered by all the eight 20 MHz channels
         RunOne(p20Index,
-               HeRu::RuSpec(HeRu::RU_2x996_TONE, 1, true),
+               MakeRuSpec(RuType::RU_2x996_TONE, 1, p80),
                width,
                {0, 1, 2, 3, 4, 5, 6, 7});
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-ru-allocation-test.cc ns-3.45/src/wifi/test/wifi-ru-allocation-test.cc
--- ns-3.44/src/wifi/test/wifi-ru-allocation-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-ru-allocation-test.cc	2025-06-01 20:34:45.643702300 -0700
@@ -675,7 +4174,28 @@
 WifiRuAllocationTestSuite::WifiRuAllocationTestSuite()
     : TestSuite("wifi-ru-allocation", Type::UNIT)
 {
-    AddTestCase(new Wifi20MHzIndicesCoveringRuTest(), TestCase::Duration::QUICK);
+    AddTestCase(new Wifi20MHzIndicesCoveringRuTest(WIFI_STANDARD_80211ax),
+                TestCase::Duration::QUICK);
+    AddTestCase(new Wifi20MHzIndicesCoveringRuTest(WIFI_STANDARD_80211be),
+                TestCase::Duration::QUICK);
+    AddTestCase(new WifiNumRusInChannelTest(WIFI_MOD_CLASS_HE), TestCase::Duration::QUICK);
+    AddTestCase(new WifiNumRusInChannelTest(WIFI_MOD_CLASS_EHT), TestCase::Duration::QUICK);
+    AddTestCase(new WifiRusOfTypeInChannelTest(WIFI_MOD_CLASS_HE), TestCase::Duration::QUICK);
+    AddTestCase(new WifiRusOfTypeInChannelTest(WIFI_MOD_CLASS_EHT), TestCase::Duration::QUICK);
+    AddTestCase(new WifiCentral26TonesRusInChannelTest(WIFI_MOD_CLASS_HE),
+                TestCase::Duration::QUICK);
+    AddTestCase(new WifiCentral26TonesRusInChannelTest(WIFI_MOD_CLASS_EHT),
+                TestCase::Duration::QUICK);
+    AddTestCase(new WifiEqualSizedRusTest(WIFI_MOD_CLASS_HE), TestCase::Duration::QUICK);
+    AddTestCase(new WifiEqualSizedRusTest(WIFI_MOD_CLASS_EHT), TestCase::Duration::QUICK);
+    AddTestCase(new WifiSubcarrierGroupsTest(WIFI_MOD_CLASS_HE), TestCase::Duration::QUICK);
+    AddTestCase(new WifiSubcarrierGroupsTest(WIFI_MOD_CLASS_EHT), TestCase::Duration::QUICK);
+    AddTestCase(new WifiRuPhyIdxTo80MHzIdxAndFlagsTest(WIFI_MOD_CLASS_HE),
+                TestCase::Duration::QUICK);
+    AddTestCase(new WifiRuPhyIdxTo80MHzIdxAndFlagsTest(WIFI_MOD_CLASS_EHT),
+                TestCase::Duration::QUICK);
+    AddTestCase(new WifiRuOverlappingTest(WIFI_MOD_CLASS_HE), TestCase::Duration::QUICK);
+    AddTestCase(new WifiRuOverlappingTest(WIFI_MOD_CLASS_EHT), TestCase::Duration::QUICK);
 }
 
 static WifiRuAllocationTestSuite g_wifiRuAllocationTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-test.cc ns-3.45/src/wifi/test/wifi-test.cc
--- ns-3.44/src/wifi/test/wifi-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-test.cc	2025-06-01 20:34:45.643702300 -0700
@@ -1508,7 +1508,7 @@
  *
  * The scenario considers a UDP transmission between a 40 MHz 802.11ac station and a
  * 40 MHz 802.11ac access point. All transmission parameters are checked so as
- * to ensure that only 2 {starting frequency, channelWidth, Number of subbands
+ * to ensure that only 3 {starting frequency, channelWidth, Number of subbands
  * in SpectrumModel, modulation type} tuples are used.
  *
  * See \bugid{2843}
@@ -1688,33 +1688,48 @@
     // {starting frequency, channelWidth, Number of subbands in SpectrumModel, modulation type}
     // tuples
     std::size_t numberTuples = m_distinctTuples.size();
-    NS_TEST_ASSERT_MSG_EQ(numberTuples, 2, "Only two distinct tuples expected");
-    NS_TEST_ASSERT_MSG_EQ(std::get<0>(m_distinctTuples[0]) - Hz_u{20e6},
+    NS_TEST_ASSERT_MSG_EQ(numberTuples, 3, "Only three distinct tuples expected");
+    NS_TEST_EXPECT_MSG_EQ(std::get<0>(m_distinctTuples[0]) - Hz_u{20e6},
                           std::get<0>(m_distinctTuples[1]),
                           "The starting frequency of the first tuple should be shifted 20 MHz to "
                           "the right wrt second tuple");
     // Note that the first tuple should the one initiated by the beacon, i.e. non-HT OFDM (20 MHz)
-    NS_TEST_ASSERT_MSG_EQ(std::get<1>(m_distinctTuples[0]),
+    NS_TEST_EXPECT_MSG_EQ(std::get<1>(m_distinctTuples[0]),
                           MHz_u{20},
                           "First tuple's channel width should be 20 MHz");
-    NS_TEST_ASSERT_MSG_EQ(std::get<2>(m_distinctTuples[0]),
+    NS_TEST_EXPECT_MSG_EQ(std::get<2>(m_distinctTuples[0]),
                           193,
                           "First tuple should have 193 subbands (64+DC, 20MHz+DC, inband and 64*2 "
                           "out-of-band, 20MHz on each side)");
-    NS_TEST_ASSERT_MSG_EQ(std::get<3>(m_distinctTuples[0]),
+    NS_TEST_EXPECT_MSG_EQ(std::get<3>(m_distinctTuples[0]),
                           WifiModulationClass::WIFI_MOD_CLASS_OFDM,
                           "First tuple should be OFDM");
-    // Second tuple
-    NS_TEST_ASSERT_MSG_EQ(std::get<1>(m_distinctTuples[1]),
+    // Second tuple: data frames, VHT (40 MHz)
+    NS_TEST_EXPECT_MSG_EQ(std::get<1>(m_distinctTuples[1]),
                           channelWidth,
                           "Second tuple's channel width should be 40 MHz");
-    NS_TEST_ASSERT_MSG_EQ(std::get<2>(m_distinctTuples[1]),
+    NS_TEST_EXPECT_MSG_EQ(std::get<2>(m_distinctTuples[1]),
                           385,
                           "Second tuple should have 385 subbands (128+DC, 40MHz+DC, inband and "
                           "128*2 out-of-band, 40MHz on each side)");
-    NS_TEST_ASSERT_MSG_EQ(std::get<3>(m_distinctTuples[1]),
+    NS_TEST_EXPECT_MSG_EQ(std::get<3>(m_distinctTuples[1]),
                           WifiModulationClass::WIFI_MOD_CLASS_VHT,
                           "Second tuple should be VHT_OFDM");
+    // Third tuple: control response frames, non-HT (OFDM) duplicate (40 MHz)
+    NS_TEST_EXPECT_MSG_EQ(std::get<0>(m_distinctTuples[1]),
+                          std::get<0>(m_distinctTuples[2]),
+                          "The starting frequency of the third tuple should be the same as the "
+                          "second tuple");
+    NS_TEST_EXPECT_MSG_EQ(std::get<1>(m_distinctTuples[2]),
+                          channelWidth,
+                          "Third tuple's channel width should be 40 MHz");
+    NS_TEST_EXPECT_MSG_EQ(std::get<2>(m_distinctTuples[2]),
+                          385,
+                          "Third tuple should have 385 subbands (128+DC, 40MHz+DC, inband and "
+                          "128*2 out-of-band, 40MHz on each side)");
+    NS_TEST_EXPECT_MSG_EQ(std::get<3>(m_distinctTuples[2]),
+                          WifiModulationClass::WIFI_MOD_CLASS_OFDM,
+                          "Third tuple should be OFDM");
 }
 
 //-----------------------------------------------------------------------------
@@ -3579,7 +3594,7 @@
      * standard tables)
      * @returns true if data rates are the same, false otherwise
      */
-    bool CheckDataRate(HeRu::RuType ruType,
+    bool CheckDataRate(RuType ruType,
                        std::string mcs,
                        uint8_t nss,
                        Time guardInterval,
@@ -3593,7 +3608,7 @@
 }
 
 bool
-HeRuMcsDataRateTestCase::CheckDataRate(HeRu::RuType ruType,
+HeRuMcsDataRateTestCase::CheckDataRate(RuType ruType,
                                        std::string mcs,
                                        uint8_t nss,
                                        Time guardInterval,
@@ -3634,18 +3649,18 @@
     bool retval = true;
 
     // 26-tone RU, browse over all MCSs, GIs and Nss's (up to 4, current max)
-    retval = retval && CheckDataRate(HeRu::RU_26_TONE, "HeMcs0", 1, NanoSeconds(800), 9) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs1", 1, NanoSeconds(1600), 17) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs2", 1, NanoSeconds(3200), 23) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs3", 1, NanoSeconds(3200), 30) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs4", 2, NanoSeconds(1600), 100) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs5", 3, NanoSeconds(1600), 200) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs6", 4, NanoSeconds(1600), 300) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs7", 4, NanoSeconds(3200), 300) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs8", 4, NanoSeconds(1600), 400) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs9", 4, NanoSeconds(3200), 400) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs10", 4, NanoSeconds(1600), 500) &&
-             CheckDataRate(HeRu::RU_26_TONE, "HeMcs11", 4, NanoSeconds(3200), 500);
+    retval = retval && CheckDataRate(RuType::RU_26_TONE, "HeMcs0", 1, NanoSeconds(800), 9) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs1", 1, NanoSeconds(1600), 17) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs2", 1, NanoSeconds(3200), 23) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs3", 1, NanoSeconds(3200), 30) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs4", 2, NanoSeconds(1600), 100) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs5", 3, NanoSeconds(1600), 200) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs6", 4, NanoSeconds(1600), 300) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs7", 4, NanoSeconds(3200), 300) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs8", 4, NanoSeconds(1600), 400) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs9", 4, NanoSeconds(3200), 400) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs10", 4, NanoSeconds(1600), 500) &&
+             CheckDataRate(RuType::RU_26_TONE, "HeMcs11", 4, NanoSeconds(3200), 500);
 
     NS_TEST_EXPECT_MSG_EQ(
         retval,
@@ -3653,12 +3668,12 @@
         "26-tone RU  data rate verification for different MCSs, GIs, and Nss's failed");
 
     // Check other RU sizes
-    retval = retval && CheckDataRate(HeRu::RU_52_TONE, "HeMcs2", 1, NanoSeconds(1600), 50) &&
-             CheckDataRate(HeRu::RU_106_TONE, "HeMcs9", 1, NanoSeconds(800), 500) &&
-             CheckDataRate(HeRu::RU_242_TONE, "HeMcs5", 1, NanoSeconds(1600), 650) &&
-             CheckDataRate(HeRu::RU_484_TONE, "HeMcs3", 1, NanoSeconds(1600), 650) &&
-             CheckDataRate(HeRu::RU_996_TONE, "HeMcs5", 1, NanoSeconds(3200), 2450) &&
-             CheckDataRate(HeRu::RU_2x996_TONE, "HeMcs3", 1, NanoSeconds(3200), 2450);
+    retval = retval && CheckDataRate(RuType::RU_52_TONE, "HeMcs2", 1, NanoSeconds(1600), 50) &&
+             CheckDataRate(RuType::RU_106_TONE, "HeMcs9", 1, NanoSeconds(800), 500) &&
+             CheckDataRate(RuType::RU_242_TONE, "HeMcs5", 1, NanoSeconds(1600), 650) &&
+             CheckDataRate(RuType::RU_484_TONE, "HeMcs3", 1, NanoSeconds(1600), 650) &&
+             CheckDataRate(RuType::RU_996_TONE, "HeMcs5", 1, NanoSeconds(3200), 2450) &&
+             CheckDataRate(RuType::RU_2x996_TONE, "HeMcs3", 1, NanoSeconds(3200), 2450);
 
     NS_TEST_EXPECT_MSG_EQ(retval,
                           true,
